﻿/*
** Vnice's 特殊字符函数库
** 作者： Molay
** 版本： 2.0
** 修改时间： 2007-11-24
** 版权所有： Vnice's Group, Inc.
*/
package Vnices{
	public class FunString {
		// 计算字符长度，返回在一定设置下所需要的文本框的大概长度
		// 注意：此函数仅仅依据“宋体 12px”的格式算出，对于其他格式请更改相应参数
		public static function strLength(str:String):Number {
			str = str.replace(new RegExp("[\\f\\r\\t\\n]","g"),"");
			var a:Array = str.split("");
			var n:Number = 0;
			for (var i in a) {
				if (i != 0) {
					n += (FunString.isChinese(a[i])) ? 12 : 6 ;
				} else {
					n += (FunString.isChinese(a[i])) ? 16.2 : 10.2 ;
				}
			}
			return n;
		}
		
		// 判断是否为双字节的字符
		public static function isChinese(target_str:String):Boolean {
			var pattern:RegExp = /[ a-z0-9\!\"\#\$\%\&\'\(\)\*\+\,\-\.\/\:\;\<\=\>\?\@\[\\\]\^\_\`\{\|\}\~]/gi;
			return !pattern.test(target_str);
		}
	}
}