﻿/*
** Vnice's 物体界面生成类
** 作者： Molay
** 版本： 2.0
** 修改时间： 2007-07-01
** 版权所有： Vnice's Group, Inc.
*/
package Vnices{
	import flash.display.*;
	public class Objects extends Sprite {
		// 生成圆形 [目标元件、半径、填充颜色、填充Alpha、线条粗细、线条颜色、线条Alpha]
		public static function drawCircle(target_mc:Sprite,radius:Number,fillColor:Number,fillAlpha:Number,linePx:Number,lineColor:Number,lineAlpha:Number):void {
			target_mc.graphics.beginFill(fillColor,fillAlpha);
			target_mc.graphics.lineStyle(linePx,lineColor,lineAlpha);
			target_mc.graphics.drawCircle(radius,radius,radius);
			target_mc.graphics.endFill();
		}
		// 生成椭圆 [目标元件、宽度、高度、填充颜色、填充Alpha、线条粗细、线条颜色、线条Alpha]
		public static function drawEllipse(target_mc:Sprite,boxWidth:Number,boxHeight:Number,fillColor:Number,fillAlpha:Number,linePx:Number,lineColor:Number,lineAlpha:Number):void {
			target_mc.graphics.beginFill(fillColor,fillAlpha);
			target_mc.graphics.lineStyle(linePx,lineColor,lineAlpha);
			target_mc.graphics.drawEllipse(0,0,boxWidth,boxHeight);
			target_mc.graphics.endFill();
		}
		// 生成圆角矩形 [目标元件、宽度、高度、圆角度、填充颜色、填充Alpha、线条粗细、线条颜色、线条Alpha]
		public static function drawRoundedRectangle(target_mc:Sprite,boxWidth:Number,boxHeight:Number,cornerRadius:Number,fillColor:Number,fillAlpha:Number,linePx:Number,lineColor:Number,lineAlpha:Number):void {
			target_mc.graphics.beginFill(fillColor,fillAlpha);
			target_mc.graphics.lineStyle(linePx,lineColor,lineAlpha);
			target_mc.graphics.drawRoundRect(0,0,boxWidth,boxHeight,cornerRadius);
			target_mc.graphics.endFill();
		}
		// 生成矩形 [目标元件、宽度、高度、填充颜色、填充Alpha、线条粗细、线条颜色、线条Alpha]
		public static function drawRectangle(target_mc:Sprite,boxWidth:Number,boxHeight:Number,fillColor:Number,fillAlpha:Number,linePx:Number,lineColor:Number,lineAlpha:Number):void {
			target_mc.graphics.beginFill(fillColor,fillAlpha);
			target_mc.graphics.lineStyle(linePx,lineColor,lineAlpha);
			target_mc.graphics.drawRect(0,0,boxWidth,boxHeight);
			target_mc.graphics.endFill();
		}
	}
}